---@alias XyPair { x: number, y: number }

---@alias Elasticity fun(self, velocity: XyPair)

T = {
    ---@type XyPair
    XyPair = { x = 1, y = 1 },
    bool = true,
    number = 0,
    numberArray = { 1, 2, 3 },
    str = "",
    marker = {},
    ---@type fun(self)
    SelfFunction = function(self) end,
    ---@type Elasticity
    Elasticity = {
        isRigid = true,
        apply = function() end,
    },
}

---@generic T
---@param t T
---@return nil | T
function Maybe(t)
    return { maybe = t }
end
