Burger = {}

local gfx <const> = playdate.graphics

function Burger.reset(o)
    o.position = {
        x = 20,
        y = 50,
    }
    o.velocity = {
        x = 100 * math.random(),
        y = 150 * (math.random() - 1),
    }
    o.size = {
        x = 10,
        y = 10,
    }
    o.mass = T.marker
    return o
end

function Burger.new()
    return setmetatable(Burger.reset({}), { __index = Burger })
end

function Burger:draw()
    gfx.fillCircleAtPoint(burger.position.x, burger.position.y, 10)
end
